// This class contains the functions necessary to "create" random numbers, using a seed provided by the user.
#include <iostream>
#include <fstream>

class cRNG
{
	public:
/*		cRNG()
		{
			SetSeed(12345);
		};
*/
		cRNG(int seed = 12345)
		{
		    SetSeed(seed);
		};
		
		~cRNG()
		{
			
		};
		
		void SetSeed(const unsigned int &s_)
		{
			s[i = 0] = s_;
			
			for (int j = 1; j < 624; j++) s[j] = 1812433253*(s[j - 1]^(s[j - 1] >> 30)) + j;
		};
		
		unsigned int Rand()
		{
			if (i == 0)
			{
				for (int j = 0; j < 624; j++)
				{
					unsigned int k = (s[j] & (1 << 31)) + (s[(j + 1) % 624] & 0x7fffffff);
					
					s[j] = s[(j + 397) % 624]^(k >> 1);
					
					if (k & 1) s[j] ^= 2567483615;
				}
			}
			
			unsigned int k = s[i];
			
			k ^= (k >> 11);
			k ^= ((k << 7) & 2636928640);
			k ^= ((k << 15) & 4022730752);
			k ^= (k >> 18);
			
			i = (i + 1) % 624;
			
			return k;
		};
		
		double Randf()
		{
			unsigned int k = Rand();
			
			return ((double)(k & 4294967295) / 4294967295.0);
		};
		
	private:
		int i;
		unsigned int s[624];
};
